<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Responsible GenAI Testing Suite</title>
    <base href="templates/">
    <link rel="icon" type="image/x-icon" href="/frontend/static/images/acn_logo.png">
    <!--img src="/frontend/static/images/acn_logo.png"-->
    <!--link rel="stylesheet" href="{{ url_for('static', path='/style/`stylesheet.css') }}"-->
    <script src="https://unpkg.com/htmx.org@1.9.12"></script>
    <script src="https://cdn.tailwindcss.com"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.9.2/html2pdf.bundle.min.js"></script>
    <script src="/frontend/static/script/functions.js"></script>
    <link rel="stylesheet" href="/frontend/static/style/stylesheet.css">

</head>

<body class="gradient-bg min-h-screen flex items-center justify-center">
     <!-- Splash Screen -->
     <div class="hidden splash-screen gradient-bg">
        <div class="content">
            <h1>Welcome to the Responsible GenAI Testing Suite</h1>
        </div>
    </div>
    <div class="container mx-auto my-6 p-8 bg-white shadow-lg rounded-lg" id="main-content">
        <h1 id="title-with-logo" class="text-4xl font-bold mb-8 text-center text-violet-700">
            Responsible GenAI Testing Suite<img src="/frontend/static/images/acn_logo.png" alt="accenture logo" width="20px" align='right'>
        </h1>
        <!-- Login Form -->
        <form id="step4" hx-post="/login" hx-target="#login-response">
            <div class="mb-4">
                <label for="username" class="block text-sm font-medium text-gray-700">Username</label>
                <input type="text" id="username" name="username" required class="mt-1 p-2 block w-full border border-gray-300 rounded-md">
            </div>
            <div class="mb-4">
                <label for="password" class="block text-sm font-medium text-gray-700">Password</label>
                <input type="password" id="password" name="password" required class="mt-1 p-2 block w-full border border-gray-300 rounded-md">
            </div>
            <button type="submit" id="login-button" class="text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4 bg-violet-700">
                Log In
            </button>
            <div id="login-response" class="mt-4"></div>
        </form>
        <!-- Step 0: Welcome -->
        <div id="step0" class="hidden">
            <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Welcome to the Responsible GenAI Testing Suite</h2>
            <div class="grid grid-cols-1 lg:grid-cols-3 gap-8">
                <!-- Left Column -->
                <div class="lg:col-span-1">
                    <h1 class="text-xl font-bold mb-8 text-center text-violet-700">What is this tool for?</h1>
                    <p class="text-sm text-gray-700 mb-4">
                        <ul>
                            <li><strong>Measuring Responsibility:</strong> The primary purpose of this tool is to systemically quantify the level of responsibility demonstrated by a LLM. It performs 19 tests across several principles.</li>
                            <li><strong>Quality Assurance:</strong> This product serves as a quality assurance since it tests if the models and the design adhere to ethical standards and exhibit responsible behavior in various contexts.</li>
                            <li><strong>Continuous Improvement:</strong> This tool can be integrated into the development workflow, so to identify potential regressions.</li>
                        </ul>
                    </p>
                </div>
                <!-- Middle Column -->
                <div class="lg:col-span-1">
                    <h1 class="text-xl font-bold mb-8 text-center text-violet-700">Whom is this tool for?</h1>
                    <p class="text-sm text-gray-700 mb-4">
                        <ul>
                            <li><strong>Data Scientists:</strong> Data scientists who work on projects using LLMs need reliable and systematic methods to assess the performance and behavior of their generative AI models during development.</li>
                            <li><strong>AI Engineers:</strong> AI engineers responsible for developing AI architectures and implementing generative AI models require tools that help them gauge the ethical implications and decision-making capabilities of their creations. This tool serves as a valuable resource for evaluating these aspects.</li>
                        </ul>
                    </p>
                </div>
                <!-- Right Column -->
                <div class="lg:col-span-1">
                    <h1 class="text-xl font-bold mb-8 text-center text-violet-700">How to use it?</h1>
                    <p class="text-sm text-gray-700 mb-4">
                        <ul>
                            <li><strong>Step 1:</strong> Choose the relevant domain and model, and input your question for evaluation.</li>
                            <li><strong>Step 2:</strong> Choose the principles to test from Fairness, Robustness, Transparency, Privacy, Security and Soundness.</li>
                            <li><strong>Step 3:</strong> Evaluate and collect the possible mitigations. The results can be downloaded for audit or tracking the improvements.</li>
                        </ul>
                    </p>
                </div>
            </div>
            <div>
            <p align="right">
                <button onclick="showStep(1)" class="bg-violet-700 hover:bg-violet-900 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Get Started</button>
            </p>
            </div>
        </div>
        <form id="evaluation-form" hx-post="/evaluate" hx-target="#evaluation-results" onsubmit="setLoading()">
            <!-- Step 1: Client and Domain Selection and Input Question -->
            <div id="step1" class="hidden">
                <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Model Selection</h2>
                <div class="grid grid-cols-1 lg:grid-cols-2 gap-8">
                    <!-- left col -->
                    <div class="lg:col-span-1">
                        <div class="flex flex-col mb-6">
                            <label for="client-select" class="text-gray-700 font-semibold mb-2">Choose the Domain</label>
                            <select 
                                id="client-select"
                                name="client"
                                class="border border-gray-300 rounded-md px-3 py-2 focus:outline-none focus:ring-2 focus:ring-violet-700"
                                hx-get="/update_domains/"
                                hx-target="#domain-select"
                                hx-trigger="change"
                                onchange="checkInputs()"
                            >
                                <option value="">Select a Domain</option>
                                {% for client in solution_dict %}
                                    <option value="{{ client }}">{{ client }}</option>
                                {% endfor %}
                            </select>
                        </div>
                    </div>
                    <!-- right col -->
                    <div class="lg:col-span-1">
                        <div class="flex flex-col mb-6">
                            <label for="domain-select" class="text-gray-700 font-semibold mb-2">Choose the Model</label>
                            <select id="domain-select" name="domain" class="border border-gray-300 rounded-md px-3 py-2 focus:outline-none focus:ring-2 focus:ring-violet-700">
                                <option value="">Select a Model </option>
                                {% include 'domains.html' %}
                            </select>
                        </div>
                    </div>
                </div>
                <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Custom Model</h2>
                <div class="grid grid-cols-1 lg:grid-cols-2 gap-8">
                    <div class="lg:col-span-1">
                        <div class="flex flex-col mb-6">
                            <label for="ext_endpoint" class="text-gray-700 font-semibold mb-2">Insert your endpoint url</label>
                            <input 
                                type="text"
                                placeholder="http://custom-model-endpoint.com"
                                id="ext-endpoint"
                                name="ext_endpoint" 
                                class="mt-1 p-2 block w-full border border-gray-300 rounded-md"
                                oninput=checkInputs()
                            >
                            </div>
                    </div>
                    <div class="lg:col-span-1">
                        <div class="flex flex-col mb-6">
                            In order to evaluate your endpoint, it has to be exposed following this structure: <a href="\docs" class = "font-medium text-violet-600 dark:text-violet-500 hover:underline">Swagger Doc</a>
                        </div>
                    </div>
                </div>

                <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Input Question</h2>
                <div class="grid grid-cols-1 lg:grid-cols-2 gap-8">
                    <!-- left col -->
                    <div class="lg:col-span-1">
                        <label for="input-question" class="text-gray-700 font-semibold mb-2">Input Question</label>
                        <textarea id="input-question" name="input_question" rows="4" class="border border-gray-300 rounded-md px-3 py-2 w-full focus:outline-none focus:ring-2 focus:ring-violet-700" oninput="checkInputs()"></textarea>
                    </div>
                    <!-- right col -->
                    <div class="lg:col-span-1">
                        <p class="text-sm text-gray-700 mb-2">
                            <div>
                                The input question is necessary to evaluate: <b>Fairness</b>, <b>Robustness</b> and <b>Transparency</b>.
                                These principles, unlike the others, do not need a predefined set of tests; but, they require a question made by the user which is representative of the documents stored in its knowledge base.
                            </div>
                            </br>
                            <div>
                                The input question should pertain to a potential scenario for which the model has been designed.  
                            </div>                            
                        </p>
                    </div>
                </div>
                <!-- Bottoni Step 1 -->
                <div class="lg:col-span-6">
                    <div class="left-btn">
                        <button type="button" onclick="showStep(0)" class="w-15 h-15 bg-gray-500 hover:bg-gray-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Back to Welcome</button>
                    </div>
                    <div class="right-btn">
                        <button type="button" id="next-on-step-1" onclick="checkInputs(); showStep(2)" class="w-15 h-15 bg-gray-500 hover:bg-gary-500 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4" disabled>Next</button>
                    </div>
                </div>
            </div>
             <!-- Step 2: Legend and Checkboxes -->
             <div id="step2" class="hidden grid grid-cols-1 lg:grid-cols-6">
                <div class="lg:col-span-6">
                    <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Choose one or several principles to test</h2>
                    <div class="text-sm px-2 py-2">
                        <ul>
                            <div>
                                <table class="w-full border-separate border-spacing-y-2">
                                    <thead class="rounded border border-gray-300 bg.gray-50 text-lg">
                                        <tr>
                                            <th>Select</th>
                                            <th>Principles</th>
                                            <th>Sub Principles</th>
                                        </tr>
                                    </thead>
                                    <tbody class="rounded border border-gray-300">
                                        {% for criterion_name, criterion in CRITERIA_DICT.items() %}
                                        <tr class="border border-gray-300 bg-gray-50">
                                            <td>
                                                <input type="checkbox" name="principles" id="principle-{{ criterion_name }}" value="{{ criterion_name }}" class="w-5 h-5 rounded border border-gray-300 focus:ring-2 focus:ring-violet-700 ml-4" checked>
                                            </td>
                                            <td class="text-center">
                                                <label class="font-bold" for="principle-{{ criterion_name }}">{{ criterion_name }}</label>
                                            </td>
                                            <td class="w-full mb-2 mt-2">
                                                <div class="ml-4 w-full mb-2 mt-2">
                                                    {% for key, val in criterion.items() %}
                                                    <div class="mr-6">
                                                        <b>{{ key }}</b>: {{ val['description'] }}
                                                    </div>
                                                    {% endfor %}
                                                </div>
                                            </td>
                                        </tr>
                                        {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                        </ul>
                    </div>
                </div>
                <!-- Bottoni Step 2 -->
                <div class="lg:col-span-6">
                    <div class="left-btn">
                        <button type="button" onclick="showStep(1)" class="w-15 h-15 bg-gray-500 hover:bg-gray-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Back to Model Selection</button>
                    </div>
                    <div class="right-btn">
                        <button type="submit" onclick="checkInputs()" id="evaluate-button" class="w-15 h-12 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4 bg-gray-500" disabled >Run Evaluation</button >
                    </div>
                </div>
            </div>
        </form>
        <!-- Step 3: Evaluation Results -->
        <div id="step3" class="hidden grid grid-cols-1 lg:grid-cols-12 gap-8 mt-8 mb-8">
            <div class="lg:col-span-12">
                <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Evaluation Results</h2>
            </div>
            <div class="lg:col-span-12">
                <p>
                    <strong class="ml-4">Tested Configuration:</strong>
                    <br>
                    <ul class="text-sm ml-4">
                        <li><strong>Domain:</strong> <span id="client-selected"></span></li>
                        <li><strong>Model:</strong> <span id="domain-selected"></span></li>
                        <li><strong>Input Question:</strong> <span id="input-questioned"></span></li>
                        <li><strong>Timestamp:</strong> <span id="timestamp"></span></li>
                    </ul>
                </p>
            </div>
            <div id="evaluation-results" class="no-page-break lg:col-span-12 mt-6 p-4 rounded-lg">
                <!-- Evaluation results HTML is in evaluation_results.html -->
            </div>
            <div id="buttons-on-step-3" class="lg:col-span-12">
                <div class="left-btn">
                    <button onclick="showStep(1)" class="bg-gray-500 hover:bg-gray-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Start Again</button>
                    <button onclick="showStep(2)" class="bg-gray-500 hover:bg-gray-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Back to Principles</button>
                </div>
                <div class="right-btn">
                    <button onclick="expandAndDownload()" class="bg-violet-700 hover:bg-violet-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Download as PDF</button>
                </div>
            </div>
        </div>
    </div>
</body>
</html>
